# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Figur, Rechteck, Ereignisbehandlung

class RegenTropfen (Figur):
    """
    Stellt einen Regentropfen in seinen verschiedenen Phasen dar.
    """
    
    def __init__(self, x = 50, y = 50):  
        """
        Positioniert den Tropfen und legt den Fallwinkel fest
        Boden und Vorboden werden eingerichtet
        """  
        super().__init__()
        Vorboden()
        Boden()
        self.FigurTropfenFestlegen()
        self.GanzNachVornBringen()
        self.PositionSetzen(x, y)        
        self.WinkelSetzen(270)
        
    def FigurTropfenFestlegen(self):
        """
        Stellt den Regentropfen im Fall dar
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenDreieck(-50, 0, 30, -30, 30, 30, "blau")
        self.FigurteilFestlegenEllipse(10, -30, 40, 60, "blau")
        
    def FlachWerden(self):
        """
        Stellt den Regentropfen während des Aufpralls dar
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenDreieck(-50, 0, 30, -30, 30, 30, "blau")
        self.FigurteilFestlegenRechteck(30, -45, 15, 90, "blau")
        
    def PfuetzeWerden(self):
        """
        Stellt den Regentropfen als Pfütze dar
        """ 
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenRechteck(30, -45, 15, 90, "blau")
        
    def AktionAusfuehren(self):
        """
        Methode wird aufgerufen, wenn die Figur handeln soll.
        """    
        if self.BeruehrtFarbe("schwarz"):
            self.PfuetzeWerden()            
        elif self.BeruehrtFarbe("weiß"):
            self.FlachWerden()
            self.Gehen(5)
        else:            
            self.Gehen(10)
            
class Boden(Rechteck):
    """
    Stellt den Boden dar.
    """
    
    def __init__(self):  
        """
        Setzt Position, Größe und Farbe
        """   
        super().__init__()
        self.GroesseSetzen(800, 5)
        self.FarbeSetzen("schwarz")
        self.PositionSetzen(0, 516)
        
class Vorboden(Rechteck):
    """
    Simuliert die Information, dass der Boden gleich erreicht ist.
    """
    
    def __init__(self):  
        """
        Setzt Position, Größe und Farbe
        """  
        super().__init__()
        self.GroesseSetzen(800, 15)
        self.FarbeSetzen("weiß")
        self.PositionSetzen(0, 501)
