# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Figur, Text

class Monster(Figur):
    """
    Verwaltet das Monster
    """
    # Hier muss die Initialisierungsmethode ergänzt werden.
    
    def GeschlossenGelb(self):
        """
        Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "gelb")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenOrange(self):
        """
        Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "orange")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenRot(self):
        """
        Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
        """   
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenGruen(self):
        """
        Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "grün")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def Offen(self, farbe):
        """
        Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, farbe)
        self.FigurteilFestlegenDreieck(0, 0, 50, -10, 50, 10, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def Schliessen(self, farbe):
        """
        Stellt das in einer der Farben gelb, orange, rot bzw. grün mit geschlossenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        if farbe == "gelb": 
            self.GeschlossenGelb()
        if farbe == "orange":
            self.GeschlossenOrange()
        if farbe == "rot":
            self.GeschlossenRot()
        if farbe == "grün":
            self.GeschlossenGruen()
            
    def Oeffnen(self, farbe):
        """
        Stellt das in einer der Farben gelb, orange, rot bzw. grün mit offenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        if farbe == "gelb" or farbe == "orange" or farbe == "rot" or farbe == "grün":
            self.Offen(farbe)
            
    def TasteGedrueckt (self, taste):
        """
        Die Aktionsmethode für gedrückte Tasten.
        -- Parameter taste KeyCode der gedrückten Taste
        """    
        if taste == "left":        
            self.WinkelSetzen(180)
        elif taste == "up":            
            self.WinkelSetzen(90)
        elif taste == "right":
            self.WinkelSetzen(0)
        elif taste == "down":
            self.WinkelSetzen(270)
            
    def AktionAusfuehren(self):
        """
        Das Monster geht maximal bis zum Rand
        """
        if self.WinkelGeben() == 0:
            if self.XPositionGeben()< 790:
                self.Gehen(10)   
        elif self.WinkelGeben() == 90:
            if self.YPositionGeben()> 30:
                self.Gehen(10)
        elif self.WinkelGeben() == 180:
            if self.XPositionGeben()> 10:
                self.Gehen(10)
        elif self.WinkelGeben() == 270:
            if self.YPositionGeben()< 500:
                self.Gehen(10)
                
class Kruemel(Figur):
    """
    Klasse zur Beschreibung der Krümel.
    """
    
    def FigurFestlegen(self):
        """
        Stellt den orangen Krümel dar.
        """   
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-5, -5, 10, 10, "orange")
        
    def AktionAusfuehren(self):
        """
        Der Krümel verschwindet bei Berührung
        """
        if self.Beruehrt():
            self.Entfernen()
            
Kruemel()
Monster()
